TRUE = 1;
FALSE = 0;
fprintf(1,'Generacin de mapas solares de Canarias\n');
%Lectura del fichero
fprintf(1,'La matriz se lee de un fichero de texto de la forma:\n');
fprintf(1,'A(1,1), A(1,2), A(1,3),A(1,4)\n') 
fprintf(1,'A(2,1), A(2,2), A(2,3), A(2,4)\n');
fprintf(1,'..., A(n,1), A(n,2), A(n,3), A(n,4)\n');
fprintf(1,'sabiendo que A(i,1) corresponde a las coordenadas x,\n');
fprintf(1,'A(i,2) corresponde a las coordenadas y\n');
fprintf(1,'A(i,3) corresponde a las coordenadas z\n');
fprintf(1,'A(i,4) corresponde al dato de albedo\n');
fprintf(1,'Se ha creado ya el fichero de entrada? - escriba Y o N.\n');
AA = input(' ','s');
if AA == 'Y' | AA == 'y' 
    fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
    fprintf(1,'for example:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
    OK = FALSE;
    ACABAR=FALSE;
    while OK == FALSE
        fprintf(1,'Escriba la longitud de X y de Y en lineas separadas.\n');
        A = input(' ');
        B = input(' ');
        fprintf(1,'Escriba el numero de puntos en X y en Y en lineas separadas.\n');
        N = input(' ');
        M = input(' ');
        if A > 0 & B > 0 & N > 0 & M > 0
            coor=load(NAME,'-ascii');
            OK = TRUE;
            fclose(INP);
        end;
    end;
    X=coor(:,1);
    Y=coor(:,2);
    Z=coor(:,3);
    RO=coor(:,4);
else
    fprintf(1,'El programa finalizara para que el fichero de entrada pueda ser creado.\n');
    ACABAR=TRUE;
end;
if ACABAR==FALSE
% Datos de los incrementos de x y de y
C = A/(N-1);
D = B/(M-1);
%Triangulacin de Delaunay
tri = delaunay (X,Y);
figure(1);
trisurf (tri,X,Y,zeros(size(X)));
title('TRIANGULACIN DE DELAUNAY');
% Numero de tringulos que se obtienen con la triangulacin
H = length(tri);
%Se pide la fecha y se comprueba si sta es correcta
MESES= [31	28	31	30	31	30	31	31	30	31	30	31];
OK=FALSE;
while OK==FALSE
    fprintf(1,'Introduzca el nmero del da.\n');
    DIA=input(' ');
    fprintf(1,'Introduzca el nmero del mes. Por ejemplo: 2 (si el mes es Febrero)\n');
    MES=input(' ');
	if (MES>=1) & (MES<=12) & (DIA <= MESES(MES))
        OK=TRUE;       
    else
        fprintf(1,'La fecha no es correcta\n');
    end;
end;
%Clculo del nmero de das j
j=0;
m=MES-1;
if m>0
    for b=1:m
		j=j+MESES(b);
	end;
end;
j=j+DIA;
%Se pide la hora y se comprueba que es correcta.
OK= FALSE;
while OK == FALSE
    fprintf(1,'Escriba la hora sin los minutos. Por ejemplo: 14 (si la hora fuera 14:05).\n');
    T1= input(' ');
    if T1>= 0 & T1 <= 24 
        OK = TRUE;
    else
        fprintf(1,'La hora debe estar comprendida entre 0 y 23.\n');
    end;
end;
OK= FALSE;
while OK == FALSE
    fprintf(1,'Escriba a continuacin los minutos. Por ejemplo: 5 (si la hora fuera 14:05).\n');
    min=input(' ');
    if min>=0 & min<=59
        OK=TRUE;
    else
        fprintf(1,'Los minutos deben estar comprendidos entre 0 y 59.\n');   
    end;
end;
%Pasar los minutos a horas
MIN=min/60;
HORA=T1+MIN;
%Se pide la latitud
OK = FALSE;
while OK == FALSE
    fprintf(1,'Escriba el grado de latitud,\n');
    fprintf(1,'positivo hacia el norte y negativo hacia el sur.\n');
    fprintf(1,'Por ejemplo: 28.06 (Las Palmas de Gran Canaria), \n');
    fprintf(1,'28.28 (Santa Cruz de Tenerife), 28.30 (Puerto del Rosario, Fuerteventura), \n');
    fprintf(1,'29.00 (Arrecife, Lanzarote), 28.05 (San Sebastin de la Gomera),\n');
    fprintf(1,'27.48 (Valverde, El Hierro), 28.41 (Santa Cruz de la Palma).\n');
    y = input(' ');
    if y >= -90 & y <= 90
        OK = TRUE;
    else
        fprintf(1,'El grado de latitud debe ser mayor que -90 y menor que 90.\n');
    end;
end;
%Se pide la longitud
OK = FALSE;
while OK == FALSE
    fprintf(1,'Escriba el grado de longitud,\n');
    fprintf(1,'positivo hacia el oeste y negativo hacia el este del meridiano Greenwich.\n');
    fprintf(1,'Por ejemplo: 15.25 (Las Palmas de Gran Canaria),\n');
    fprintf(1,'16.15 (Santa Cruz de Tenerife), 13.53 (Puerto del Rosario, Fuerteventura)\n');
    fprintf(1,'13.34 (Arrecife, Lanzarote), 17.08 (San Sebastin de la Gomera),\n');
    fprintf(1,'17.54 (Valverde, El Hierro), 17.45 (Santa Cruz de la Palma).\n');
    long= input(' ');
    if long >= -180 & long <= 180
        OK = TRUE;
    else
        fprintf(1,'El valor de la longitud debe estar comprendido entre -180 y 180. \n');
    end;
end;
% CLCULO DE LA RADIACIN DIRECTA
ji = 2*pi*j/365.25;
E = 1 + 0.03344*cos (ji - 0.048869);
I0 = 1367;
G0 = I0*E;
TLK=[2.5 2.5 3 3 3.5 3.5 3.5 3.5 3.5 3 3 2.5]; 
d = asin (0.3978*sin(ji - 1.4 + 0.0355*sin (ji - 0.0489)));
C31 = cos (y*(pi/180))* cos (d);
C33 = sin (y*(pi/180))* sin (d);    
%edt=ecuacin del tiempo
%Entrada de la edt a travs de un fichero
%Lectura del fichero
fprintf(1,'La matriz de la ecuacin del tiempo se lee de un fichero de texto de la forma:\n');
fprintf(1,'A(1,1), A(1,2), A(1,3)...A(1,12)\n') 
fprintf(1,'A(2,1), A(2,2), A(2,3)... A(2,12)\n');
fprintf(1,'..., A(31,1), A(31,2), A(31,3)... A(31,12)\n');
fprintf(1,'sabiendo que cada columna corresponde a un determinado mes,\n');
fprintf(1,'y cada fila a un determinado da\n');
fprintf(1,'Se ha creado ya el fichero de entrada? - escriba Y o N.\n');
AA = input(' ','s');
if AA == 'Y' | AA == 'y' 
    fprintf(1,'Escriba el nombre del fichero de la forma - disco:\\nombre.ext\n');
    fprintf(1,'for example:   A:\\DATA.DTA\n');
    NAME = input(' ','s');
    INP = fopen(NAME,'rt');
    ecu=load(NAME,'-ascii');
    fclose(INP);
    edt=ecu(:,:);
else
    fprintf(1,'El programa finalizara para que el fichero de entrada pueda ser creado.\n');
    ACABAR=TRUE;
end;
if ACABAR==FALSE
%Clculo de la hora solar
longmer=0;
if MES>=4 | MES<=10
    a=2;
else
    a=1;
end;
t=HORA-edt(DIA,MES)-(long-longmer)*(4/60)-(a);
T = 0.261799*(t - 12);
h0 = asin (C31*cos (T) + C33);
Vh0ref=0.061359*(0.1594+1.123*h0 + 0.065656*(h0)^2)/(1 + 28.9344*h0 + 277.3971*(h0)^2);
h0ref = h0 + Vh0ref;
for i=1:H
    zeta(i)=(Z(tri(i,1))+Z(tri(i,2))+Z(tri(i,3)))/3;
end;
for i=1:H
    pp0(i) = exp(-zeta(i)/8434.5);
end;
for i=1:H
    m(i) = (pp0(i))/(sin (h0ref) + 0.50572*(h0ref + 6.07995)^-1.6364);
end;
for i=1:H
    if m(i)<=20
        dR(i) = 1/(6.6296 + 1.7513*m(i) - 0.1202*(m(i)^2) + 0.0065*(m(i)^3) - 0.00013*(m(i)^4));
    else
        dR(i) = 1/(10.4 + 0.718*m(i));
    end;
end;
for i=1:H
    B0c(i) = G0*exp(-0.8662*TLK(MES)*m(i)*dR(i)); 
end;
%Barrer malla de tringulos y mirar si es horizontal o inclinado
%Superficie horizontal o inclinada?
n=zeros(H,3);
for i=1:H
    for j=1:3
        V12(j)=coor(tri(i,2),j)-coor(tri(i,1),j);
        V13(j)=coor(tri(i,3),j)-coor(tri(i,1),j);
    end;
%Producto vectorial, clculo de la normal.
n(i,:)=cross(V12,V13);
end;
n1=[1 1 0];
for i=1:H
    for j=1:3
        V3(j)=n(i,j);
    end;
    n2(i)=dot(V3,n1);
end;
%a)Superficie horizontal
C11 = sin (y*(pi/180))*cos (d);
C13 = -cos (y*(pi/180))*sin (d);
C22 = cos (d);
A0 = acos ((C11*cos (T) + C13)/(((C22*sin (T))^2)+ ((C11*cos (T) + C13)^2))^1/2);
for i=1:H
    Bhc(i) = B0c(i)*sin(h0);
end;
%b)Superficie inclinada
%Clculo de AN y de YN
np=zeros(H,3);
for i=1:H
    np(i,1)=n(i,1);
    np(i,2)=n(i,2);
end;
ux=[1 0 0];
for i=1:H
    modnp=0;
    modn=0;
        for j=1:3
            npro(j)=np(i,j);
            V3(j)=n(i,j);
            modnp=modnp+(npro(j))^2;
            modn=modn+(V3(j))^2;
        end;
    b1(i)=dot(npro,ux);
    modnp=(modnp)^0.5;
    AN(i)=acos(b1(i)/modnp);
    b2(i)=dot(V3,npro);
    modn=(modn)^0.5;
    B(i)=acos(b2(i)/(modn*modnp));
    YN(i)=pi/2-B(i);
end;
for i=1:H
    if n2(i)~=0
        yi(i)= asin(-cos(y*(pi/180))*sin(YN(i))*cos(AN(i))+sin(y*(pi/180))*cos(YN(i)));
        Ci31(i)= cos(yi(i))*cos(d);
        Ci33(i)= sin(yi(i))*sin(d);
        li(i)= atan(-(sin(YN(i))*sin(AN(i)))/(sin(y*(pi/180))*sin(YN(i))*cos(AN(i))+ cos(y*(pi/180))*cos(YN(i))));
        dexp(i)= asin(Ci31(i)*cos(T-li(i))+Ci33(i));
        Bic(i) = Bhc(i)*sin(dexp(i))/sin(h0);
    else
        Bic(i) = Bhc(i);
    end;
end;
%Representacin de la radiacin directa
figure(2);
trisurf(tri,X,Y,Z,Bic);
title('RADIACIN DIRECTA');
pause;
%CLCULO DE LA RADIACIN DIFUSA
%a)Superficie horizontal
Tn=-0.015843+0.030543*TLK(MES)+0.0003797*(TLK(MES))^2;
A11=0.26463-0.061581*TLK(MES)+0.0031408*(TLK(MES))^2;
if (A11*Tn)<0.0022
	A1=0.0022/Tn;
else
  A1=A11;
end;
A2=2.04020+0.018945*TLK(MES)-0.011161*(TLK(MES))^2;
A3=-1.3025+0.039231*TLK(MES)+0.0085079*(TLK(MES))^2;
Fd=A1+A2*sin(h0)+A3*(sin(h0)^2);
Dhc=G0*Tn*Fd;
%b)Superficie inclinada
%Factor de sombra FS (consideramos que siempre vale 1)
FS=1;
for i=1:H
    if n2(i)==0
        %Superficies horizontales que ya han sido calculadas.
        Dic(i)=Dhc;
    else
        %Superficies inclinadas
        if dexp(i)<0 | h0>=0
            %Superficies en sombra
            N(i)=0.25227;
            ri(i)=(1+cos(YN(i)))/2;
            F(i)=ri(i)+(sin(YN(i))-YN(i)*cos(YN(i))-pi*(sin(YN(i)/2)^2))*N(i); 
            Dic(i)=Dhc*(F(i));
        else
            %Superficie sin sombra
            G0h=G0*sin(h0);
            AALN=A0-AN(i);
                if -pi<=AALN<=pi
                    ALN=AALN;
                else
                    if AALN>pi
                        ALN=AALN-2*pi;
                    else
                        ALN=AALN+2*pi;
                    end;
                end;
            Kb(i)=Bhc(i)/G0h;
            N(i)=0.00263-0.712*Kb(i)-0.6883*(Kb(i)^2);
            ri(i)=(1+cos(YN(i)))/2;
            F(i)=ri(i)+(sin(YN(i))-YN(i)*cos(YN(i))-pi*(sin(YN(i)/2)^2))*N(i);
                if h0>=0.1
                    Dic(i)=Dhc*(F(i)*(1-Kb(i))+Kb(i)*sin(dexp(i))/(sin(h0))); 
                else
                    Dic(i)=Dhc*(F(i)*(1-Kb(i))+Kb(i)*((sin(YN(i))*cos(ALN))/(0.1-0.008*h0)));
                end; 
        end;
    end;
end;
%Representacin de la radiacin difusa en superficie inclinada
figure(3);
trisurf(tri,X,Y,Z,Dic);
title('RADIACIN DIFUSA');
pause;
%CLCULO DE LA RADIACIN REFLEJADA
for i=1:H
    albedo(i)=(RO(tri(i,1))+RO(tri(i,2))+RO(tri(i,3)))/3;
end;
for i=1:H
    Ri(i) = albedo(i)*(Bhc(i)+Dhc)*(1-cos(YN(i)))/2;
end;
%Representacin de la radiacin reflejada
figure(4);
trisurf(tri,X,Y,Z,Ri);
title('RADIACIN REFLEJADA');
pause;
%RADIACIN NETA
for i=1:H
Rn(i)= Bic(i)+Dic(i)+Ri(i);
end;
%Representacin de la radiacin neta
figure(5);
trisurf(tri,X,Y,Z,Rn);
title('RADIACIN NETA');
pause;
end;
end;